<?php

class EvNewsletterSignupsController extends EvNewsletterSignupsAppController
{
	public $adminActions = array(
		'admin_export'
	);

	public function signup()
	{
		if (! empty($this->request->data)) {

			// reformat if it's ajax post
			if (! isset($this->request->data['NewsletterSignup'])) {
				$this->request->data['NewsletterSignup'] = array(
					'name' => $this->request->data['name'],
					'email' => $this->request->data['email']
				);
				unset($this->request->data['name'], $this->request->data['email']);
			}

			if ($this->NewsletterSignup->save($this->request->data)) {

				// success, either return success for ajax or set to flash for displaying
				if ($this->request->is('ajax')) {

					return $this->render('NewsletterSignups.Notifications/success', 'ajax');

				} else {

					$this->Session->setFlash($this->render('NewsletterSignups.Notifications/success', ''), 'default', array(), 'newsletter');
				}

			} else {

				// failed, either return success for ajax or set to flash for displaying
				if ($this->request->is('ajax')) {

					return $this->render('NewsletterSignups.Notifications/error', 'ajax');

				} else {

					$this->Session->setFlash($this->render('NewsletterSignups.Notifications/error', ''), 'default', array(), 'newsletter');
				}
			}
		}

		// no post
		$this->redirect(
			$this->referer()
		);
	}

	public function admin_export()
	{
		$output = "";

		$data = $this->NewsletterSignup->find('all');

		if (! empty($data)) {

			$output = "Name, Email\n";

			foreach ($data as $subscriber) {

				if (! empty($subscriber['NewsletterSignup']['email'])) {

					$output .= stripslashes($subscriber['NewsletterSignup']['name']).",";
					$output .= stripslashes($subscriber['NewsletterSignup']['email'])."\n";
				}
			}
		} else {

			$output = 'There are no emails in the newsletter mailing list';
		}

		$date = date("j_M_Y");

		// setup the headers
		$this->response->disableCache();
		$this->response->length(strlen($output));
		$this->response->type('csv');
		$this->response->download("newsletter_signups_".$date.".csv");
		$this->response->body($output);

		// output csv
		$this->response->send();
	}

}
